package com.huimv.receive.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.receive.common.utils.Result;
import com.huimv.receive.common.utils.ResultCode;
import com.huimv.receive.entity.BaseLocation;
import com.huimv.receive.entity.BaseProcess;
import com.huimv.receive.mapper.BaseProcessMapper;
import com.huimv.receive.service.IBaseLocationService;
import com.huimv.receive.service.IBaseProcessService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 流程表 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-07-21
 */
@Service
public class BaseProcessServiceImpl extends ServiceImpl<BaseProcessMapper, BaseProcess> implements IBaseProcessService {

    @Autowired
    private IBaseLocationService baseLocationService;
    @Override
    public Result getOne(Integer userId ,String farmId,String vistitType) {
        BaseProcess one = this.getOne(new QueryWrapper<BaseProcess>().eq("admission_user_id", userId).orderByDesc("id").last("limit 1"));
        if (ObjectUtil.isNotEmpty(one)){
            return new Result(ResultCode.SUCCESS,one);
        }
        BaseProcess baseProcess = new BaseProcess();
        List<BaseLocation> list = baseLocationService.list(new QueryWrapper<BaseLocation>().eq("farm_id", farmId).eq("vistit_type", vistitType));
        StringBuilder allLocation = new StringBuilder();
        StringBuilder allLocationId = new StringBuilder();
        StringBuilder allLocationStatus = new StringBuilder();
        for (BaseLocation baseLocation : list) {
            allLocation.append(baseLocation.getLocationName()).append(",");
            allLocationId.append(baseLocation.getId()).append(",");
            allLocationStatus.append("0").append(",");
        }
        baseProcess.setAllLocation(allLocation.toString());
        baseProcess.setAllLocationId(allLocationId.toString());
        baseProcess.setAllLocationStatus(allLocationStatus.toString());
        return new Result(ResultCode.SUCCESS,baseProcess);
    }
}
